package gui;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * TinyEditor.java
 *
 * Created on 29-Jul-2009, 19:15:14
 */

import parsing.*;

import java.awt.Font;
import java.util.*;


/**
 *
 * @author arnaud
 */
public class TinyEditor extends javax.swing.JFrame {

    /** Creates new form TinyEditor */
    public TinyEditor() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        run = new javax.swing.JButton();
        mainSubPanel = new javax.swing.JPanel();
        inScrollPane = new javax.swing.JScrollPane();
        inTextArea = new javax.swing.JTextArea();
        outScrollPane = new javax.swing.JScrollPane();
        outTextArea = new javax.swing.JTextArea();
        
        Font font = new Font("Monospaced", Font.PLAIN, 12);
        inTextArea.setTabSize(3);
        outTextArea.setTabSize(3);
        inTextArea.setFont(font);
        outTextArea.setFont(font);
        

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        mainPanel.setLayout(new java.awt.BorderLayout());

        run.setText("Run!");
        run.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runActionPerformed(evt);
            }
        });
        mainPanel.add(run, java.awt.BorderLayout.PAGE_END);

        mainSubPanel.setLayout(new java.awt.GridLayout(1, 2));

        inTextArea.setColumns(20);
        inTextArea.setRows(5);
        inScrollPane.setViewportView(inTextArea);

        mainSubPanel.add(inScrollPane);

        outTextArea.setColumns(20);
        outTextArea.setRows(5);
        outScrollPane.setViewportView(outTextArea);

        mainSubPanel.add(outScrollPane);

        mainPanel.add(mainSubPanel, java.awt.BorderLayout.CENTER);

        getContentPane().add(mainPanel, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>

    private void runActionPerformed(java.awt.event.ActionEvent evt) {
        String source = inTextArea.getText(); 
    	try {
    		outTextArea.setText("");
    		List<Tree<Header>> ptrees = Parsing.getParseForest(source);
    		for (Tree<Header> pt : ptrees) {
    			outTextArea.append(pt.toString());
			}
    	}
    	catch(ParsingException pe)
    	{
    		outTextArea.setText(pe.toString());
    	}
    	
    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new TinyEditor().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify
    private javax.swing.JScrollPane inScrollPane;
    private javax.swing.JTextArea inTextArea;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JPanel mainSubPanel;
    private javax.swing.JScrollPane outScrollPane;
    private javax.swing.JTextArea outTextArea;
    private javax.swing.JButton run;
    // End of variables declaration

}
