package parsing;


public class ParsingException extends RuntimeException {
	public String description;
	public SrcLoc loc;
	
	public ParsingException(Stream s, String d)
	{
		super(s.loc.toString() + ": " +  d);
		description = d;
		this.loc = s.loc;
	}

	public ParsingException(WithLoc wl, String d)
	{
		super(wl.start.toString() + ": " +  d);
		description = d;
		this.loc = wl.start;
	}


	public static ParsingException latest(ParsingException[] pes)
	{
		ParsingException lastPe = pes[0];

		for (ParsingException pe : pes)
		{
			// TODO: take line into account
			if (pe.loc.caret > lastPe.loc.caret)
				lastPe = pe;
		}

		return lastPe;
	}

	public String toString()
	{
		return loc.toString() + ": " + description;
	}
}
