package parsing;



public class Token extends WithLoc 
{
	final String str;

	Token(String str, SrcLoc loc)
	{
		this.str = str;
		this.start = loc;
		this.end = loc.after(str.length() - 1);
	}


	public static Token read(String pattern, Stream stream)
	{
		if (stream.str.startsWith(pattern))
		{
			Token tok = new Token(pattern, stream.loc);
			
			//if (stream.str.length() > pattern.length() && StreamHandler.isBreak(stream.str.charAt(pattern.length())) == false)
			//	throw new ParsingException(stream, "White space or delimiter expected after '" + pattern + "'");
			//else
				return tok;
		}
		else
		{
			if (stream.str.length() == 0)
				throw new ParsingException(stream, "'" + pattern + "' expected but end of line reached");
			if (stream.str.length() <= 3)	
				throw new ParsingException(stream, "'" + pattern + "' expected but '" + stream.str.substring(0,stream.str.length()) + "' found");
			else
				throw new ParsingException(stream, "'" + pattern + "' expected but '" + stream.str.substring(0,3) + "...' found");
		}
	}

	public String toString()
	{
		return str;
	}
} 
