package syntax.expressions;

import java.util.Vector;

import parsing.Stream;
import parsing.Token;





public class AnonFunctionDef extends Value 
{
	public Vector<Symbol> params;
	public Expression result;
	
	public static AnonFunctionDef read(Stream stream)
	{
		Token         fun    = Token.read("function", stream);
		
		Tuple<Symbol> paramsTuple = Tuple.readSymbolTuple(stream.after(fun));
		Token         arrow  = Token.read("->", stream.after(paramsTuple));
		Expression    result = Expression.read(stream.after(arrow), 0);
		
		AnonFunctionDef funDef = new AnonFunctionDef();
		
		funDef.start = fun.start;
		funDef.end = result.end;
		
		funDef.params = paramsTuple.members;
		funDef.result = result;
		
		return funDef;
	}
	
	
	public Value eval()
	{
		return this;
	}
}
