package syntax.expressions;

import parsing.*;
import syntax.headers.CaseClause;
import java.util.*;


public class CaseOf extends RightHandSide {

	public Expression expr;
	public List<CaseClause> clauses;
	
	
	public static CaseOf read(Stream stream)
	{
		
		Token         cas    = Token.read("case", stream);
		Expression    expr   = Expression.read(stream.after(cas), 0);
		Token         of     = Token.read("of", stream.after(expr));
		
		CaseOf caseOf = new CaseOf();
		
		caseOf.start = cas.start;
		caseOf.end = of.end;
		caseOf.expr = expr;
		
		return caseOf;
	}
	
}
