package syntax.expressions;

import java.util.Vector;

import parsing.*;

public class FunctionCall extends Expression 
{
	public Symbol fun;
	public Vector<Expression> args;
	
	
	public static FunctionCall read(Stream stream)
	{
		Symbol        fun   = Symbol.read(stream);
		Tuple<Expression> argsTuple = Tuple.readExpressionTuple(stream.after(fun));
		
		FunctionCall funCall = new FunctionCall();
		
		funCall.start = fun.start;
		funCall.end = argsTuple.end;
		
		funCall.fun = fun;
		funCall.args = argsTuple.members;
		
		
		return funCall;
	}
	
	public Value eval()
	{
		throw new RuntimeException("not implemented");
	}

	public String toString()
	{
		return fun + Tuple.asString(args);
	}


}
