package syntax.expressions;
import parsing.*;


public class PrimitiveValue extends Value {

	byte[] bytes;

	
	public PrimitiveValue(String type, byte[] bytes, SrcLoc start, SrcLoc end)
	{
		this.type = type;
		this.bytes = bytes;
		this.start = start;
		this.end = end;
	}
	
	public boolean equals(PrimitiveValue other)
	{
		return this.type.equals(other.type) && this.bytes.equals(other.bytes);
	}


	
	public String toString()
	{
		
		if (type.equals("Bool"))
		{
			if (bytes[0] == 1)
				return "True";
			else
				return "False";
		}
		
		
		return type + ": " + bytes;
	}

	public static PrimitiveValue read(Stream stream)
	{
		try {
			return VInt.read(stream);
		}
		catch (ParsingException pe1) {
			try {
				return VString.read(stream);
			}
			catch (ParsingException pe2) {
				throw new ParsingException(stream, "Failed to match primitive value.");
			}
		}
	
	/*

		String str = stream.str;
		String tok = StreamHandler.grabToken(stream);
		

		// try to parse an int
		if (tok.matches("-?[0-9]+"))
		{
			byte[] b = ByteTransforms.fromNum(tok);
			SrcLoc s = stream.loc;
			SrcLoc e = stream.loc.after(tok.length() - 1);
			return new PrimitiveValue("Int", b, s, e);
		}
		
		// try to parse a string
		if (str.charAt(0) == '"')
		{
			int taken = 1;
		
			while (taken < str.length() && str.charAt(taken) != '"')
				taken++;
			
			if (taken == str.length())
				throw new ParsingException(stream.after(taken), "Closing quotes missing");
			
			byte[] b = str.substring(1, taken).getBytes();
			SrcLoc s = stream.loc;
			SrcLoc e = stream.loc.after(taken);
			
			return new PrimitiveValue("String", b, s, e);
		}
		
		throw new ParsingException(stream, "No matching primitive value");
		*/
	}
}
